/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.reactivex.ext.web;

import java.util.Map;
import io.reactivex.Observable;
import io.reactivex.Flowable;
import io.reactivex.Single;
import io.reactivex.Completable;
import io.reactivex.Maybe;

/**
 *
 * <p/>
 * NOTE: This class has been automatically generated from the {@link io.vertx.ext.web.Locale original} non RX-ified interface using Vert.x codegen.
 */

@io.vertx.lang.rx.RxGen(io.vertx.ext.web.Locale.class)
public class Locale {

  @Override
  public String toString() {
    return delegate.toString();
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    Locale that = (Locale) o;
    return delegate.equals(that.delegate);
  }
  
  @Override
  public int hashCode() {
    return delegate.hashCode();
  }

  public static final io.vertx.lang.rx.TypeArg<Locale> __TYPE_ARG = new io.vertx.lang.rx.TypeArg<>(    obj -> new Locale((io.vertx.ext.web.Locale) obj),
    Locale::getDelegate
  );

  private final io.vertx.ext.web.Locale delegate;
  
  public Locale(io.vertx.ext.web.Locale delegate) {
    this.delegate = delegate;
  }

  public io.vertx.ext.web.Locale getDelegate() {
    return delegate;
  }

  @Deprecated()
  public static io.vertx.reactivex.ext.web.Locale create() { 
    io.vertx.reactivex.ext.web.Locale ret = io.vertx.reactivex.ext.web.Locale.newInstance(io.vertx.ext.web.Locale.create());
    return ret;
  }

  @Deprecated()
  public static io.vertx.reactivex.ext.web.Locale create(String language) { 
    io.vertx.reactivex.ext.web.Locale ret = io.vertx.reactivex.ext.web.Locale.newInstance(io.vertx.ext.web.Locale.create(language));
    return ret;
  }

  @Deprecated()
  public static io.vertx.reactivex.ext.web.Locale create(String language, String country) { 
    io.vertx.reactivex.ext.web.Locale ret = io.vertx.reactivex.ext.web.Locale.newInstance(io.vertx.ext.web.Locale.create(language, country));
    return ret;
  }

  @Deprecated()
  public static io.vertx.reactivex.ext.web.Locale create(String language, String country, String variant) { 
    io.vertx.reactivex.ext.web.Locale ret = io.vertx.reactivex.ext.web.Locale.newInstance(io.vertx.ext.web.Locale.create(language, country, variant));
    return ret;
  }

  /**
   * Returns the language as reported by the HTTP client.
   * @return language
   */
  @Deprecated()
  public String language() { 
    String ret = delegate.language();
    return ret;
  }

  /**
   * Returns the country as reported by the HTTP client.
   * @return variant
   */
  @Deprecated()
  public String country() { 
    String ret = delegate.country();
    return ret;
  }

  /**
   * Returns the variant as reported by the HTTP client.
   * @return variant
   */
  @Deprecated()
  public String variant() { 
    String ret = delegate.variant();
    return ret;
  }


  public static  Locale newInstance(io.vertx.ext.web.Locale arg) {
    return arg != null ? new Locale(arg) : null;
  }
}
