/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.reactivex.ext.web.api.contract.openapi3;

import java.util.Map;
import io.reactivex.Observable;
import io.reactivex.Flowable;
import io.reactivex.Single;
import io.reactivex.Completable;
import io.reactivex.Maybe;

/**
 *
 * <p/>
 * NOTE: This class has been automatically generated from the {@link io.vertx.ext.web.api.contract.openapi3.OpenAPI3RequestValidationHandler original} non RX-ified interface using Vert.x codegen.
 */

@io.vertx.lang.rx.RxGen(io.vertx.ext.web.api.contract.openapi3.OpenAPI3RequestValidationHandler.class)
public class OpenAPI3RequestValidationHandler implements io.vertx.reactivex.ext.web.api.contract.HTTPOperationRequestValidationHandler, io.vertx.core.Handler<io.vertx.reactivex.ext.web.RoutingContext> {

  @Override
  public String toString() {
    return delegate.toString();
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    OpenAPI3RequestValidationHandler that = (OpenAPI3RequestValidationHandler) o;
    return delegate.equals(that.delegate);
  }
  
  @Override
  public int hashCode() {
    return delegate.hashCode();
  }

  public static final io.vertx.lang.rx.TypeArg<OpenAPI3RequestValidationHandler> __TYPE_ARG = new io.vertx.lang.rx.TypeArg<>(    obj -> new OpenAPI3RequestValidationHandler((io.vertx.ext.web.api.contract.openapi3.OpenAPI3RequestValidationHandler) obj),
    OpenAPI3RequestValidationHandler::getDelegate
  );

  private final io.vertx.ext.web.api.contract.openapi3.OpenAPI3RequestValidationHandler delegate;
  
  public OpenAPI3RequestValidationHandler(io.vertx.ext.web.api.contract.openapi3.OpenAPI3RequestValidationHandler delegate) {
    this.delegate = delegate;
  }

  public io.vertx.ext.web.api.contract.openapi3.OpenAPI3RequestValidationHandler getDelegate() {
    return delegate;
  }

  /**
   * Something has happened, so handle it.
   * @param event the event to handle
   */
  public void handle(io.vertx.reactivex.ext.web.RoutingContext event) { 
    delegate.handle(event.getDelegate());
  }

  /**
   * Function that parse the operation specification and generate validation rules
   */
  public void parseOperationSpec() { 
    delegate.parseOperationSpec();
  }


  public static  OpenAPI3RequestValidationHandler newInstance(io.vertx.ext.web.api.contract.openapi3.OpenAPI3RequestValidationHandler arg) {
    return arg != null ? new OpenAPI3RequestValidationHandler(arg) : null;
  }
}
