/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.reactivex.ext.web.templ.thymeleaf;

import java.util.Map;
import io.reactivex.Observable;
import io.reactivex.Flowable;
import io.reactivex.Single;
import io.reactivex.Completable;
import io.reactivex.Maybe;
import org.thymeleaf.templatemode.TemplateMode;

/**
 * A template engine that uses the Thymeleaf library.
 *
 * <p/>
 * NOTE: This class has been automatically generated from the {@link io.vertx.ext.web.templ.thymeleaf.ThymeleafTemplateEngine original} non RX-ified interface using Vert.x codegen.
 */

@io.vertx.lang.rx.RxGen(io.vertx.ext.web.templ.thymeleaf.ThymeleafTemplateEngine.class)
public class ThymeleafTemplateEngine extends io.vertx.reactivex.ext.web.common.template.TemplateEngine {

  @Override
  public String toString() {
    return delegate.toString();
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    ThymeleafTemplateEngine that = (ThymeleafTemplateEngine) o;
    return delegate.equals(that.delegate);
  }
  
  @Override
  public int hashCode() {
    return delegate.hashCode();
  }

  public static final io.vertx.lang.rx.TypeArg<ThymeleafTemplateEngine> __TYPE_ARG = new io.vertx.lang.rx.TypeArg<>(    obj -> new ThymeleafTemplateEngine((io.vertx.ext.web.templ.thymeleaf.ThymeleafTemplateEngine) obj),
    ThymeleafTemplateEngine::getDelegate
  );

  private final io.vertx.ext.web.templ.thymeleaf.ThymeleafTemplateEngine delegate;
  
  public ThymeleafTemplateEngine(io.vertx.ext.web.templ.thymeleaf.ThymeleafTemplateEngine delegate) {
    super(delegate);
    this.delegate = delegate;
  }

  public io.vertx.ext.web.templ.thymeleaf.ThymeleafTemplateEngine getDelegate() {
    return delegate;
  }

  /**
   * Create a template engine using defaults
   * @param vertx 
   * @return the engine
   */
  public static io.vertx.reactivex.ext.web.templ.thymeleaf.ThymeleafTemplateEngine create(io.vertx.reactivex.core.Vertx vertx) { 
    io.vertx.reactivex.ext.web.templ.thymeleaf.ThymeleafTemplateEngine ret = io.vertx.reactivex.ext.web.templ.thymeleaf.ThymeleafTemplateEngine.newInstance(io.vertx.ext.web.templ.thymeleaf.ThymeleafTemplateEngine.create(vertx.getDelegate()));
    return ret;
  }

  /**
   * Set the mode for the engine
   * @param mode the mode
   * @return a reference to this for fluency
   */
  public io.vertx.reactivex.ext.web.templ.thymeleaf.ThymeleafTemplateEngine setMode(TemplateMode mode) { 
    delegate.setMode(mode);
    return this;
  }

  public static final TemplateMode DEFAULT_TEMPLATE_MODE = io.vertx.ext.web.templ.thymeleaf.ThymeleafTemplateEngine.DEFAULT_TEMPLATE_MODE;

  public static  ThymeleafTemplateEngine newInstance(io.vertx.ext.web.templ.thymeleaf.ThymeleafTemplateEngine arg) {
    return arg != null ? new ThymeleafTemplateEngine(arg) : null;
  }
}
